#发射检定-火焰喷射器
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:5}}}] run tag @s add slime_musket_fire5
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:5,Fuel:0}}}] run tag @s remove slime_musket_fire5
execute as @a[tag=slime_musket_fire5] run function slime_musket:fire/flamethrower_fire


#检测子弹数量
execute as @a[gamemode=!creative] store result score @s slime_musket_cartrigde run clear @s iron_nugget{Tags:["slime_musket_cartridge"]} 0
scoreboard players set @a[gamemode=creative,scores={slime_musket_cartrigde=..1}] slime_musket_cartrigde 1
execute as @a[gamemode=creative,scores={slime_musket_cartrigde=2..}] store result score @s slime_musket_cartrigde run clear @s iron_nugget{Tags:["slime_musket_cartridge"]} 0
advancement grant @a[scores={slime_musket_cartrigde=1728..}] only slime_musket:slime_musket/transporter

#水中无法开枪
execute as @a at @s anchored eyes if block ~ ~ ~ water run scoreboard players set @s slime_musket_shoot 0
execute as @a at @s anchored eyes if block ~ ~ ~ water_cauldron run scoreboard players set @s slime_musket_shoot 0

#着火时走火
execute as @a store result score @s slime_musket_firetime run data get entity @s Fire
scoreboard players add @a[scores={slime_musket_firetime=1..},nbt={SelectedItem:{tag:{load:1}}}] slime_musket_firetime1 1
execute as @a[scores={slime_musket_firetime1=20..},nbt={SelectedItem:{tag:{load:1}}}] run function slime_musket:discharge

#shift检定-装填
tag @a remove slime_musket_reloading
tag @a[scores={slime_musket_reload=1..,slime_musket_cartrigde=1..},nbt={SelectedItem:{tag:{load:0}}}] add slime_musket_reloading
scoreboard players set @a[scores={slime_musket_cooldown=1..}] slime_musket_reload 0
#弹筒发射器
execute as @a[tag=slime_musket_reloading,nbt={SelectedItem:{tag:{MusketType:6}}}] run tag @s[nbt=!{Inventory:[{Slot:-106b,tag:{Pots:2}}]}] remove slime_musket_reloading
#火焰喷射器
execute as @a[tag=slime_musket_reloading,nbt={SelectedItem:{tag:{MusketType:5}}}] run tag @s[nbt=!{Inventory:[{Slot:-106b,tag:{Pots:1}}]}] remove slime_musket_reloading
tag @a[scores={slime_musket_reload=1..},nbt={SelectedItem:{tag:{load:0}},Inventory:[{Slot:-106b,tag:{Pots:1}}]}] add slime_musket_reloading

execute as @a[scores={slime_musket_reload=1..},nbt={SelectedItem:{tag:{MusketType:5,load:1,Fuel:0}}}] at @s run function slime_musket:specialgun/load1_flamethrower
execute as @a[scores={slime_musket_reload=1..},nbt={SelectedItem:{tag:{Pots:0}},Inventory:[{Slot:-106b,id:"minecraft:blaze_powder"}]}] run function slime_musket:specialgun/fuel

scoreboard players set @a[tag=!slime_musket_reloading] slime_musket_reload 0
scoreboard players set @a[scores={slime_musket_cartrigde=..0}] slime_musket_reload 0

scoreboard players set @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{AmmoGun:1}}}] slime_musket_reload 0
execute at @a[scores={slime_musket_reload=1},nbt=!{SelectedItem:{tag:{MusketType:4}}}] run playsound item.armor.equip_chain player @a ~ ~ ~ 1.2 0.4
scoreboard players add @a[scores={slime_musket_reload=1}] slime_musket_reload 1


#清除
tag @a[nbt={SelectedItem:{tag:{load:1}}}] add slime_musket_shootable
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}},scores={slime_musket_cooldown=0}] as @s[nbt=!{SelectedItem:{tag:{ammo:0}}}] run tag @s add slime_musket_shootable
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}},scores={slime_musket_cooldown=0}] as @s[nbt=!{SelectedItem:{tag:{Fuel:0}}}] run tag @s add slime_musket_shootable
scoreboard players set @a[tag=!slime_musket_shootable] slime_musket_shoot 0
tag @a remove slime_musket_shootable

#发射冷却
scoreboard players remove @a[scores={slime_musket_cooldown=1..}] slime_musket_cooldown 1
scoreboard players add @a[scores={slime_musket_cooldown=..-1}] slime_musket_cooldown 1

#发射检定-手枪
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:1,load:1}}}] run tag @s add slime_musket_fire1
execute as @a[tag=slime_musket_fire1] run function slime_musket:fire/pistol_fire

#发射检定-步枪
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:2,load:1}}}] run tag @s add slime_musket_fire2
execute as @a[tag=slime_musket_fire2] run function slime_musket:fire/musket_fire

#发射检定-霰弹枪
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:3,load:1}}}] run tag @s add slime_musket_fire3
execute as @a[tag=slime_musket_fire3] run function slime_musket:fire/shotgun_fire

#发射检定-转轮手枪
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:4}}}] run tag @s add slime_musket_fire4
execute as @a[tag=slime_musket_fire4] run function slime_musket:fire/revolver_fire

#发射检定-弹筒抛射器
execute as @a[scores={slime_musket_shoot=1..},nbt={SelectedItem:{tag:{MusketType:6}}}] run tag @s add slime_musket_fire6
execute as @a[tag=slime_musket_fire6] run function slime_musket:fire/launcher_fire

#shift检定-刺刀
tag @a remove slime_musket_bayonet
tag @a[scores={slime_musket_bayonet=1..},nbt={SelectedItem:{tag:{MusketType:2,bayonet:0}},Inventory:[{Slot:-106b,id:"minecraft:iron_sword",Count:1b}]}] add slime_musket_bayonet
tag @a[scores={slime_musket_bayonet=1..},nbt={Inventory:[{Slot:-106b,tag:{MusketType:2,bayonet:1}}]}] add slime_musket_bayonet
scoreboard players set @a[tag=!slime_musket_bayonet] slime_musket_bayonet 0
execute at @a[scores={slime_musket_bayonet=1}] run playsound item.armor.equip_chain player @a ~ ~ ~ 1.2 0.4
scoreboard players add @a[scores={slime_musket_bayonet=1}] slime_musket_bayonet 1

#上刺刀
execute as @a[scores={slime_musket_bayonet=30..},nbt={SelectedItem:{tag:{MusketType:2,bayonet:0}},Inventory:[{Slot:-106b,id:"minecraft:iron_sword",Count:1b}]}] at @s run function slime_musket:basic/bayonet

#下刺刀
execute as @a[scores={slime_musket_bayonet=30..},nbt={Inventory:[{Slot:-106b,tag:{MusketType:2,bayonet:1}}]}] at @s run function slime_musket:basic/debayonet

#手枪装填
execute as @a[scores={slime_musket_reload=25..},nbt={SelectedItem:{tag:{MusketType:1}}}] at @s run function slime_musket:basic/reload

#步枪装填
execute as @a[scores={slime_musket_reload=36..},nbt={SelectedItem:{tag:{MusketType:2}}}] at @s run function slime_musket:basic/reload

#霰弹枪装填
execute as @a[scores={slime_musket_reload=32..},nbt={SelectedItem:{tag:{MusketType:3}}}] at @s run function slime_musket:basic/reload

#转轮手枪装填
execute as @a[scores={slime_musket_reload=12..},nbt={SelectedItem:{tag:{MusketType:4}}}] at @s run function slime_musket:basic/reload_ammo

#火焰喷射器装填
execute as @a[scores={slime_musket_reload=42..},nbt={SelectedItem:{tag:{MusketType:5}}}] at @s run function slime_musket:specialgun/load_flamethrower

#弹筒抛射器装填
execute as @a[scores={slime_musket_reload=42..},nbt={SelectedItem:{tag:{MusketType:6}}}] at @s run function slime_musket:specialgun/load_launcher


#子弹轨迹
execute at @e[tag=slime_musket_bullet] run particle smoke ~ ~ ~ 0.1 0.1 0.1 0 1 force

#清除子弹
scoreboard players add @e[tag=slime_musket_bullet] slime_musket_time 1
kill @e[tag=slime_musket_shotgunbullet,scores={slime_musket_time=5..}]
execute as @e[tag=slime_musket_bullet,nbt={inGround:1b}] run function slime_musket:basic/bulletclear

#更新手册
scoreboard players enable @a slime_musket_book
execute as @a[scores={slime_musket_book=1..}] run function slime_musket:basic/book
scoreboard players set @a slime_musket_book 0

#子弹数量显示
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}}] store result score @s slime_musket_ammodisplay run data get entity @s SelectedItem.tag.ammo
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}}] store result score @s slime_musket_ammodisplay run data get entity @s SelectedItem.tag.Fuel
execute as @a[nbt={SelectedItem:{tag:{MusketType:5}}}] run title @s actionbar [{"translate":"item.slime_musket.ammodisplay"},{"score":{"objective":"slime_musket_ammodisplay","name":"@s"}}]
execute as @a[nbt={SelectedItem:{tag:{AmmoGun:1}}}] run title @s actionbar [{"translate":"item.slime_musket.ammodisplay"},{"score":{"objective":"slime_musket_ammodisplay","name":"@s"}}]

#火焰
execute as @e[tag=slime_musket_flame] at @s run function slime_musket:fire/flame
#弹筒
execute as @e[tag=slime_musket_pot] at @s run function slime_musket:fire/pot